# all files / ol/ array.js

31% Statements 31/100
30.61% Branches 15/49
20% Functions 3/15
31% Lines 31/100

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    2471×

    1×

    1×

    1×

    1×
    304×
    304×
    8×
    296×
    8×

    288×
    288×

    288×

    288×
    5628×
    288×
    5340×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    4×
    4×
    152×
    4×

    148×
    148×

     goog.provide('ol.array');

    /**
     * Performs a binary search on the provided sorted list and returns the index of the item if found. If it can't be found it'll return -1.
     * https://github.com/darkskyapp/binary-search
     *
     * @param {Array.<*>} haystack Items to search through.
     * @param {*} needle The item to look for.
     * @param {Function=} opt_comparator Comparator function.
     * @return {number} The index of the item if found, -1 if not.
     */
    ol.array.binarySearch = function(haystack, needle, opt_comparator) {
      var mid, cmp;
      var comparator = opt_comparator || ol.array.numberSafeCompareFunction;
      var low = 0;
      var high = haystack.length;
      var found = false;

      while (low < high) {
        /* Note that "(low + high) >>> 1" may overflow, and results in a typecast
         * to double (which gives the wrong results). */
        mid = low + (high - low >> 1);
        cmp = +comparator(haystack[mid], needle);

        if (cmp < 0.0) { /* Too low. */
          low  = mid + 1;

        } else { /* Key found or too high */
          high = mid;
          found = !cmp;
        }
      }

      /* Key not found. */
      return found ? low : ~low;
    };

    /**
     * Compare function for array sort that is safe for numbers.
     * @param {*} a The first object to be compared.
     * @param {*} b The second object to be compared.
     * @return {number} A negative number, zero, or a positive number as the first
     *     argument is less than, equal to, or greater than the second.
     */
    ol.array.numberSafeCompareFunction = function(a, b) {
      return a > b ? 1 : a < b ? -1 : 0;
    };

    /**
     * Whether the array contains the given object.
     * @param {Array.<*>} arr The array to test for the presence of the element.
     * @param {*} obj The object for which to test.
     * @return {boolean} The object is in the array.
     */
    ol.array.includes = function(arr, obj) {
      return arr.indexOf(obj) >= 0;
    };

    /**
     * @param {Array.<number>} arr Array.
     * @param {number} target Target.
     * @param {number} direction 0 means return the nearest, > 0
     *    means return the largest nearest, < 0 means return the
     *    smallest nearest.
     * @return {number} Index.
     */
    ol.array.linearFindNearest = function(arr, target, direction) {
      var n = arr.length;
      if (arr[0] <= target) {
        return 0;
      } else if (target <= arr[n - 1]) {
        return n - 1;
      } else {
        var i;
        Iif (direction > 0) {
          for (i = 1; i < n; ++i) {
            if (arr[i] < target) {
              return i - 1;
            }
          }
        } else Iif (direction < 0) {
          for (i = 1; i < n; ++i) {
            if (arr[i] <= target) {
              return i;
            }
          }
        } else {
          for (i = 1; i < n; ++i) {
            if (arr[i] == target) {
              return i;
            } else Iif (arr[i] < target) {
              if (arr[i - 1] - target < target - arr[i]) {
                return i - 1;
              } else {
                return i;
              }
            }
          }
        }
        return n - 1;
      }
    };

    /**
     * @param {Array.<*>} arr Array.
     * @param {number} begin Begin index.
     * @param {number} end End index.
     */
    ol.array.reverseSubArray = function(arr, begin, end) {
      while (begin < end) {
        var tmp = arr[begin];
        arr[begin] = arr[end];
        arr[end] = tmp;
        ++begin;
        --end;
      }
    };

    /**
     * @param {Array.<VALUE>} arr The array to modify.
     * @param {Array.<VALUE>|VALUE} data The elements or arrays of elements
     *     to add to arr.
     * @template VALUE
     */
    ol.array.extend = function(arr, data) {
      var i;
      var extension = Array.isArray(data) ? data : [data];
      var length = extension.length;
      for (i = 0; i < length; i++) {
        arr[arr.length] = extension[i];
      }
    };

    /**
     * @param {Array.<VALUE>} arr The array to modify.
     * @param {VALUE} obj The element to remove.
     * @template VALUE
     * @return {boolean} If the element was removed.
     */
    ol.array.remove = function(arr, obj) {
      var i = arr.indexOf(obj);
      var found = i > -1;
      if (found) {
        arr.splice(i, 1);
      }
      return found;
    };

    /**
     * @param {Array.<VALUE>} arr The array to search in.
     * @param {function(VALUE, number, ?) : boolean} func The function to compare.
     * @template VALUE
     * @return {VALUE} The element found.
     */
    ol.array.find = function(arr, func) {
      var length = arr.length >>> 0;
      var value;

      for (var i = 0; i < length; i++) {
        value = arr[i];
        if (func(value, i, arr)) {
          return value;
        }
      }
      return null;
    };

    /**
     * @param {Array|Uint8ClampedArray} arr1 The first array to compare.
     * @param {Array|Uint8ClampedArray} arr2 The second array to compare.
     * @return {boolean} Whether the two arrays are equal.
     */
    ol.array.equals = function(arr1, arr2) {
      var len1 = arr1.length;
      if (len1 !== arr2.length) {
        return false;
      }
      for (var i = 0; i < len1; i++) {
        if (arr1[i] !== arr2[i]) {
          return false;
        }
      }
      return true;
    };

    /**
     * @param {Array.<*>} arr The array to sort (modifies original).
     * @param {Function} compareFnc Comparison function.
     */
    ol.array.stableSort = function(arr, compareFnc) {
      var length = arr.length;
      var tmp = Array(arr.length);
      var i;
      for (i = 0; i < length; i++) {
        tmp[i] = {index: i, value: arr[i]};
      }
      tmp.sort(function(a, b) {
        return compareFnc(a.value, b.value) || a.index - b.index;
      });
      for (i = 0; i < arr.length; i++) {
        arr[i] = tmp[i].value;
      }
    };

    /**
     * @param {Array.<*>} arr The array to search in.
     * @param {Function} func Comparison function.
     * @return {number} Return index.
     */
    ol.array.findIndex = function(arr, func) {
      var index;
      var found = !arr.every(function(el, idx) {
        index = idx;
        return !func(el, idx, arr);
      });
      return found ? index : -1;
    };

    /**
     * @param {Array.<*>} arr The array to test.
     * @param {Function=} opt_func Comparison function.
     * @param {boolean=} opt_strict Strictly sorted (default false).
     * @return {boolean} Return index.
     */
    ol.array.isSorted = function(arr, opt_func, opt_strict) {
      var compare = opt_func || ol.array.numberSafeCompareFunction;
      return arr.every(function(currentVal, index) {
        if (index === 0) {
          return true;
        }
        var res = compare(arr[index - 1], currentVal);
        return !(res > 0 || opt_strict && res === 0);
      });
    };